/***************
だぶ巻き ver.1.0
Copyright (c) 神崎渉瑠, 2012
http://www.wi-wi.jp/
商用、非商用にかかわらず、自由に改変、ご利用頂けます。
このライブラリを使用したことにより不具合等が生じた場合でも、作者は一切の責任を負いません。
***************/
var Dabmaki=new (function(){
var version='1.0',interval=0,timeStamp=0,tm=0,animID=-1,layers=[],image=null,sheet=null,loading=null,metrix={current:{top:0,left:0,height:0,width:0},target:{top:0,left:0,height:0,width:0}},isOpen=-1,overlay=null, layer=null,
properties= {
DELAY: [1000, 1000, 1000, 1000],
BASE_URL: null,
COLOR: '#0033FF',
BGCOLOR: '#FFE4B9',
BORDER: '1px solid blue',
RADIUS: '10px',
PADDING: '0 10px',
MASK_COLOR: '#FFFFFF',
MASK_OPACITY: 0.5,
FILE_SHEET:['sheet.png',20], // filename, image-margin
FILE_LOADING:['loading.png', {height:150}], // filename, max-width, fps
FILE_LEAD_BASE:['lead_base.png'],
FILE_LEAD_TOP:['lead_top.png'],
FILE_LEAD_BOTTOM:['lead_bottom.png'],
FILE_PULL_BASE:['pull_base.png'],
FILE_PULL_TOP:['pull_top.png'],
FILE_PULL_BOTTOM:['pull_bottom.png'],
FILE_MARGIN_TOP:['margin_top.png'],
FILE_MARGIN_BOTTOM:['margin_bottom.png'],
METRIX_LOADING:[100,15],//width,height
METRIX_SHEET:[12,12,12],//pull-width, margin-top-height, margin-bottom-height
METRIX_LEAD:[12,12,12],//width, top-height, bottom-height
METRIX_MARGIN:[0,12,0]//sheet-left, lead-top-margin, title-left
};
this.handleEvent= function(e){
if( e.type==='dblclick' && isOpen>1 ){
stopTimer();
stopEvent(e);
this.dblclick(e);
}else if( isOpen===3 ){
stopEvent(e);
return false;
}else if( isOpen!==-1){ 
stopTimer();
stopEvent(e);
this.close(e);
}else{
var tar=e.target||e.srcElement;
while(tar){
if(tar.nodeName.toUpperCase()=='A'){
break;
}
tar=tar.parentNode;
}
if(!tar){
return true;
}
stopEvent(e);
this.open(e, tar);
}
return false;
};
this.dblclick= function(e){
animSheet(1,1);
var win=window.open('about:blank', 'dabmaki');
var tpl='<body style="background-color:#fff;text-align:center;"><p><img src="%s" onclick="window.close();"></p></body>';
if( win.document || win.documentElement ){
var d=win.document||win.documentElement;
var s=image.attr('src');
d.title=s.substring(s.lastIndexOf('/')+1);
d.write(tpl.replace('%s', s));
d=s=null;
}else{
setTimeout((function(w,b,s){
return function(){
var d=w.document||w.documentElement;
d.title=s.substring(s.lastIndexOf('/')+1);
d.write(b.replace('%s', s));
w=d=b=s=null;
}
})(win, tpl,image.attr('src')), 100);
}
win=tpl=null;
return false;
};
this.open=function(e, tar){
if( tm || !tar.href){
return true;
}
timeStamp=now();
var x=mouseX(e);
var y=mouseY(e);
metrix.current.top=y;
metrix.current.left=x;
layers[2].childs[0].text(tar.title||tar.href.substring(tar.href.lastIndexOf('/')+1));
overlay.style('display', 'block');
layer.style('display','block');
makeNewImage(tar.href);
animFrames(0);
loading.moveTo(x-properties.METRIX_LOADING[0]/2, y-properties.METRIX_LOADING[1]/2);
animID=0;
interval=0;
isOpen=1;
tm=setInterval( openTimer, 1 );
};

this.close= function(e, tar){
animID=3;
timeStamp=now();
tm=setInterval( closeTimer, 1);
};
function openTimer(){
var t=now()-timeStamp;
var d=properties.DELAY[animID]||0;
t=(d===0)?d=1:(t>d)?d:t;
switch( animID ){
case 0:
animLoading(t, d);
break;
case 1:
animLead(t, d);
break;
case 2:
animSheet(t, d);
break;
default:
stopTimer();
}
}
function closeTimer(){

var t=now()-timeStamp;
if( t<300 ){return true;}//wait for dblclick
t-=300;
var d=properties.DELAY[animID]||0;
t=(d===0)?d=1:(t>d)?d:t;
switch( animID ){
case 3:
animClose(t, d);
break;
default:
stopTimer();
}
}
function stopTimer(){
if( tm ){clearInterval(tm);tm=0;}
}

function animLoading(t, dly){
if( image.element.complete && t===dly ){
animFrames(0);
timeStamp=now();
loading.style('display','none');
animID++;
}else{
loading.style('display', 'block');
animFrames(t);
}
};

function animLead(t, dly){
if( t===dly ){
animFrames(0);
timeStamp=now();
animID++;
}else{
animFrames(t);
}
var met0=metrix.current;
var met1=metrix.target;
var mtxLead=properties.METRIX_LEAD;
var mtxMargin=properties.METRIX_MARGIN;
var top=easingLead(t, met0.top, met1.top-met0.top, dly)
var left=easingLead(t, met0.left, met1.left-met0.left, dly);
var height=easingLead(t, met0.height, met1.height-met0.height, dly)+mtxLead[1];
layers[0].moveTo(left, top);
layers[0].resizeTo(null, height+mtxLead[2]);
layers[0].childs[0].resizeTo(null, height-mtxMargin[1]);
layers[0].childs[2].moveTo(null, height);
layers[0].style('display','block');

return false;
};

function animSheet(t, dly){
if(t===dly){
layer.finAnim();
timeStamp=now();
layers[2].style('display', 'block');
animID++;
isOpen=2;
}else{
animFrames(t);
}
var cw=easingSheet(t, -sheet.width(), sheet.width(), dly);
sheet.moveTo(cw, null);
layers[1].style('display', 'block');
return false;
};

function animClose(t, dly){
if( isOpen!==3 ){
animFramesR(0);
layers[2].style('display', 'none');
isOpen=3;
}
animFramesR(t);
var cw=-easing(t, 0, sheet.width(), dly);
sheet.moveTo(cw, null);

if(t===dly){
overlay.style('display','none');
layer.style('display','none');
loading.style('display','none');
for(var i=0;i<layers.length;i++){
layers[i].style('display','none');
}
animID++;
isOpen=-1;
sheet.childs[0].remove(0);
}

return false;
};

function animFrames(t){layer.anim(t);}
function animFramesR(t){layer.animR(t);}
function imageLoadedError(ev){
this.error=true;
imageLoaded.call(this, ev);
}
function imageLoaded(ev){
var im=this;
var mtxLead=properties.METRIX_LEAD,
mtxSheet=properties.METRIX_SHEET,
mtxMargin=properties.METRIX_MARGIN,
imgMargin=properties.FILE_SHEET[1]*2,
width,
height,
p,
padding=getMetrix('height')*0.05,
maxWidth=getMetrix('width')*0.8-mtxSheet[0]-mtxMargin[0],
maxHeight=getMetrix('height')*0.8-mtxSheet[1]-mtxSheet[2];

if( im.error ){
im.height=Math.floor(maxHeight/2);
im.width=Math.floor(maxWidth/2);
}else if( im.complete!=null && im.complete!=true || !im.height){
var img=new Image();
img.src=im.src;
if(!img.height){
delete img;
imageLoadedError.call(this, ev);
return false;
}else{
im=img;
img=null;
}
}
timeStamp=now();

width=im.width,
height=im.height;
metrix.current.width=mtxLead[0];
metrix.current.height=0;

var lay=layers[0];
lay.moveTo(metrix.current.left, metrix.current.top);
lay.resizeTo(null, mtxLead[1]+mtxLead[2]);
lay.childs[0].resizeTo(null, 0);
lay.childs[1].moveTo(0, null);
lay.childs[2].moveTo(null, mtxLead[1]);

layers[2].childs[1].text( im.error?'File Not Found':'' );
if( width>maxWidth || height>maxHeight ){
var ratio=Math.min(maxHeight/height, maxWidth/width);
width=Math.floor(width*ratio);
height=Math.floor(height*ratio);
layers[2].childs[1].text((Math.floor(ratio*100))+'% » Doubleclick picture to enlarge.');
}

metrix.target.height=height-mtxLead[1]+mtxSheet[1]+imgMargin;
layers[0].resizeTo(null, mtxLead[1]+mtxLead[2]+imgMargin);
layers[1].resizeTo(width+mtxSheet[0]+mtxMargin[0]+imgMargin, height+mtxSheet[1]+mtxSheet[2]+imgMargin);

p=(getMetrix('height')-height)/2-mtxSheet[1];
if( p<padding )
p=padding;
metrix.target.top=p-padding;
layers[1].moveTo(null, metrix.target.top);
p=height+mtxSheet[1]+mtxSheet[2]+imgMargin;
layers[2].moveTo(null, metrix.target.top + p);
sheet.resizeTo(width+mtxSheet[0]+mtxMargin[0]+imgMargin, p);
sheet.moveTo(-width,null);

p=width+mtxMargin[0]+imgMargin;
sheet.childs[0].resizeTo(p, height+imgMargin);
sheet.childs[1].resizeTo(p,null);
sheet.childs[2].resizeTo(p,null);
sheet.childs[3].resizeTo(null, height+imgMargin);
image.resizeTo(width, height);

var top=mtxSheet[1]+height+imgMargin;
sheet.childs[2].moveTo(null, top);
sheet.childs[3].moveTo(p, null);
sheet.childs[4].moveTo(p, null);
sheet.childs[5].moveTo(p, top);

p=(getMetrix('width')-width)/2-mtxLead[0];
metrix.target.left=p;
p+=mtxLead[0]-mtxMargin[0];
layers[1].moveTo(p, null);
layers[2].moveTo(p+mtxMargin[2], null);
layers[2].resizeTo(width-20+imgMargin, null); // 20: padding for border-radius

im=null;
};

this.config= function(p){for( var i in p ){if( properties[i]!==undefined ){properties[i]=p[i];}}};
function stopEvent(e){
if( e.preventDefault ){
e.preventDefault();
e.stopPropagation();
}
e.returnValue=false;
e.cancelBubble=true;
};

function easing(t, b, c, d){return c*t/d + b;}
function easingLead(t, b, c, d){return (t===d)?b+c:-c * Math.cos(t/d * (Math.PI/2)) + c + b;}
function easingSheet(t, b, c, d){return c*t/d + b;}

function getMetrix(p){
return ( p==='height' )?
window.innerHeight||window.clientHeight||document.documentElement.clientHeight||document.body.clientHeight:
window.innerWidth||window.clientWidth||document.documentElement.clientWidth||document.body.clientWidth;
}

this.addEvent=function(elm){
elm=elm||document;
var as=elm.getElementsByTagName('a');
for( var i=0, a, im, regImg=new RegExp('\\.(?:jpg|gif|png|svg)', 'i'), regCls=new RegExp('(?:^|\\s)dabmaki(?:\\s|$)', ''); a=as[i]; i++ ){
if( regImg.test(a.href) || regCls.test(a.className) ){
if( a.addEventListener ){
a.addEventListener('click', Dabmaki, false);
}else{
a.attachEvent('onclick', function(){Dabmaki.handleEvent(event);});
}
}
}
};
this.init=function(){
var s,d,lay;
this.addEvent();
var prop=properties;
if(prop.BASE_URL===null){
for( var i=0,scs=document.getElementsByTagName('script'),sc,s,idx,re=new RegExp(/dabmaki.js/i);sc=scs[i];i++ ){
if( !re.test((s=sc.getAttribute('src'))) ){
continue;
}
prop.BASE_URL=s.substring(0, s.lastIndexOf('/')+1);
break;
}
}
var baseURL=prop.BASE_URL;
if(prop.FILE_SHEET[0].indexOf('data:')!==0)prop.FILE_SHEET[0]=baseURL+prop.FILE_SHEET[0];
if(prop.FILE_LOADING[0].indexOf('data:')!==0)prop.FILE_LOADING[0]=baseURL+prop.FILE_LOADING[0];
if(prop.FILE_LEAD_TOP[0].indexOf('data:')!==0)prop.FILE_LEAD_TOP[0]=baseURL+prop.FILE_LEAD_TOP[0];
if(prop.FILE_LEAD_BOTTOM[0].indexOf('data:')!==0)prop.FILE_LEAD_BOTTOM[0]=baseURL+prop.FILE_LEAD_BOTTOM[0];
if(prop.FILE_LEAD_BASE[0].indexOf('data:')!==0)prop.FILE_LEAD_BASE[0]=baseURL+prop.FILE_LEAD_BASE[0];
if(prop.FILE_PULL_TOP[0].indexOf('data:')!==0)prop.FILE_PULL_TOP[0]=baseURL+prop.FILE_PULL_TOP[0];
if(prop.FILE_PULL_BOTTOM[0].indexOf('data:')!==0)prop.FILE_PULL_BOTTOM[0]=baseURL+prop.FILE_PULL_BOTTOM[0];
if(prop.FILE_PULL_BASE[0].indexOf('data:')!==0)prop.FILE_PULL_BASE[0]=baseURL+prop.FILE_PULL_BASE[0];
if(prop.FILE_MARGIN_TOP[0].indexOf('data:')!==0)prop.FILE_MARGIN_TOP[0]=baseURL+prop.FILE_MARGIN_TOP[0];
if(prop.FILE_MARGIN_BOTTOM[0].indexOf('data:')!==0)prop.FILE_MARGIN_BOTTOM[0]=baseURL+prop.FILE_MARGIN_BOTTOM[0];

var metrix;
overlay=make('div','dabmaki overlay mask',0,0,0,0);
overlay.style({zIndex:999,display:'none',width:'100%',height:'100%',position:'fixed',backgroundColor:prop.MASK_COLOR});
overlay.styleVp({opacity:prop.MASK_OPACITY});

layer=make('div','dabmaki overlay screen',0,0,0,0);
layer.style({zIndex:1000,display:'none',width:'100%',height:'100%',position:'fixed'});

metrix=prop.METRIX_LEAD;
layers[0]=make('div','dabmaki lead',0,0,0,0);
layers[0].style({display:'none'});

layers[1]=make('div','dabmaki shitaji',0,0,0,0);
layers[1].style({display:'none',overflow:'hidden'});

layers[2]=make('div','dabmaki message',0,0,0,0);
layers[2].style({display:'none',overflow:'hidden',backgroundColor:prop.BGCOLOR,color:prop.COLOR,padding:prop.PADDING,fontSize:'100%'});
layers[2].height('auto');
layers[2].styleVp({'border': prop.BORDER,'border-radius':prop.RADIUS,'opacity': 1.0});

var body=document.getElementsByTagName('body')[0];
overlay.addTo(body);
layer.addTo(body);
layers[1].addTo(layer);
layers[0].addTo(layer);
layers[2].addTo(layer);
overlay.addEvent('click', Dabmaki, false);
layer.addEvent('click', Dabmaki, false);
metrix=prop.METRIX_LEAD;
layers[0].add(make('div','lead_base',prop.METRIX_MARGIN[1],'0',metrix[0],'0',prop.FILE_LEAD_BASE,'repeat-y'));
layers[0].add(make('div','lead_top','0','0',metrix[0],metrix[1],prop.FILE_LEAD_TOP,'no-repeat'));
layers[0].add(make('div','lead_bottom','0','0',metrix[0],metrix[2],prop.FILE_LEAD_BOTTOM,'no-repeat'));
metrix=prop.METRIX_SHEET;
sheet=make('div','dabmaki sheet',0,0,0,0);
layers[1].add(sheet);
sheet.add(make('div','sheet_base',metrix[1],'0','0','0',[prop.FILE_SHEET[0]],'repeat'));
sheet.add(make('div','margin_top','0','0','0',metrix[1],prop.FILE_MARGIN_TOP,'repeat-x'));
sheet.add(make('div','margin_bottom','0','0','0',metrix[2],prop.FILE_MARGIN_BOTTOM,'repeat-x'));
sheet.add(make('div','pull_base',metrix[1],'0',metrix[0],'0',prop.FILE_PULL_BASE,'repeat-y'));
sheet.add(make('div','pull_top','0','0',metrix[0],metrix[1],prop.FILE_PULL_TOP,'no-repeat'));
sheet.add(make('div', 'pull_bottom', '0','0',metrix[0],metrix[2], prop.FILE_PULL_BOTTOM,'no-repeat'));
sheet.addEvent('click', Dabmaki, false);
metrix=prop.METRIX_LOADING;
loading=make('img', 'dabmaki loading', '0', '0', metrix[0], metrix[1], prop.FILE_LOADING, 'no-repeat');
loading.style({display:'none'});
layers[1].styleVp({'opacity': 1.0});
loading.addTo(layer);
loading.addEvent('click', Dabmaki, false);
layers[2].add(make('p','dabmaki title',0,0,0,0));
layers[2].childs[0].text('');
layers[2].childs[0].style({position:'static',left:0,top:0,width:'auto',height:'auto'});
layers[2].add(make('p','dabmaki attention',0,0,0,0));
layers[2].childs[1].text('Doubleclick picture to enlarge.');
layers[2].childs[1].style({position:'static',left:0,top:0,width:'auto',height:'auto',fontSize:'75%',textAlign:'right'});

var img=new Image();
img.src=prop.FILE_SHEET[0];img.src=prop.FILE_LOADING[0];img.src=prop.FILE_LEAD_TOP[0];img.src=prop.FILE_LEAD_BOTTOM[0];img.src=prop.FILE_LEAD_BASE[0];img.src=prop.FILE_PULL_TOP[0];img.src=prop.FILE_PULL_BOTTOM[0];img.src=prop.FILE_PULL_BASE[0];img.src=prop.FILE_MARGIN_TOP[0];img.src=prop.FILE_MARGIN_BOTTOM[0];
prop.FILE_SHEET[1]=prop.FILE_SHEET[1]||0;

img=null;
prop=null;
properties.FILE_SHEET[0]='';
delete properties.FILE_LOADING;delete properties.FILE_LEAD_TOP;delete properties.FILE_LEAD_BOTTOM;delete properties.FILE_LEAD_BASE;delete properties.FILE_PULL_TOP;delete properties.FILE_PULL_BOTTOM;delete properties.FILE_PULL_BASE;delete properties.FILE_MARGIN_TOP;delete properties.FILE_MARGIN_BOTTOM;
delete properties.BASE_URL;
delete properties.COLOR;delete properties.BGCOLOR;delete properties.BORDER;delete properties.RADIUS;delete properties.PADDING;delete properties.MASK_COLOR;delete properties.MASK_OPACITY;

function make(tag, cls, top, left, w, h, fl, rp){
var ess=new Element(tag, cls, {top:top,left:left,width:w,height:h});
if( fl )ess.bg(fl[0]);
if( rp )ess.style('backgroundRepeat', rp);
if( fl && fl[1] )ess.setAnim(fl[1]||w, fl[2]?fl[2]:10, fl[3]);
return ess;
}
};

var now;
if( Date.now ){
now=Date.now;
}else{
now=function(){ return (new Date()).getTime();}
}

function mouseY(e){
var my=e.clientY||e.pageY||e.y||0;
return my;
}
function mouseX(e){
var mx=e.clientX||e.pageX||e.x||0;
return mx;
}

function makeNewImage(src){
sheet.childs[0].remove(0);
image=new Element('img', '', {});
image.style({
margin:properties.FILE_SHEET[1]+'px'
});
sheet.childs[0].add(image);
image.moveTo(properties.METRIX_MARGIN[0],null);
image.addEvent('error', imageLoadedError);
image.addEvent('abort', imageLoadedError);
image.addEvent('load', imageLoaded);
image.addEvent('dblclick', Dabmaki);
image.attr('src', src);
}
this.destroy=function(e){
overlay.destroy(true);
layer.destroy(true);
for(var i=layers.length-1; i>=0; i-- ){
layers[i]=null;
}
overlay=image=sheet=loading=layers=layer=null;
};
this.toString=function(){return 'Dabmaki ver.'+String(version);};
this.toNumber=function(){return Number((String(version)).replace(/\D/g, ''));
};
function Element(tag,id,cls){
this.element=document.createElement(tag);this.id=this.element.id=String(id);this.element.className=String(cls);this.w=0;this.h=0;this.y=0;this.x=0;this.splite={width:0,height:0};this.aniStep=0;this.fps=0;this.fin=null;this.timeStamp=0;this.parent=null;this.childs=new Array();var ua=navigator.userAgent;this.vp=(/webkit/i).test(ua)?'-webkit-':(/msie/i).test(ua)?'-ms-':(/opera/i).test(ua)?'-o-':(/gecko/i).test(ua)?'-moz-':'';if( this.init ){this.init.apply(this,Array.prototype.slice.apply(arguments));}delete ua;
this.fns={};}
Element.prototype={
isEmptyTag:function(tag){return (this.element.nodeName==='IMG');},
addEvent:function(type,func, flg){if( typeof(func)==='function' || !this.element.addEventLisener && this.element.attachEvent){var fnslen=0;if( this.fns[type] ){fnslen=this.fns[type].length;if( typeof(func)==='function' ){this.fns[type][fnslen]=function(e){e=e||event;func.call((this===window)?e.srcElement:this,e);};}else{this.fns[type][fnslen]=function(e){e=e||event;func.handleEvent.call(func,e);};}}else{this.fns[type]=new Array();if( typeof(func)==='function' ){this.fns[type][fnslen]=function(e){e=e||event;func.call((this===window)?e.srcElement:this, e);};}else{this.fns[type][fnslen]=function(e){func.handleEvent.call(func,e||event);};}}if(this.element.addEventListener){this.element.addEventListener(type, this.fns[type][fnslen], flg||false);}else if( this.element.attachEvent ){this.element.attachEvent('on'+type, this.fns[type][fnslen]);}}else{if(this.element.addEventListener){this.element.addEventListener(type, func, flg||false);}else if( this.element.attachEvent ){this.element.attachEvent('on'+type, function(){func.handleEvent.call(func,event);} );}}},
removeEvent:function(type,func, flg){if( func ){if(this.element.removeEventListener){this.element.removeEventListener(type, func, flg||false);}else if( this.element.detachEvent ){this.element.detachEvent('on'+type, func );}}else if( this.fns[type] ){if(this.element.removeEventListener){for( var i=0;i<this.fns[type].length;i++ ){this.element.removeEventListener(type, this.fns[type][i], false);}}else if( this.element.detachEvent ){for( var i=0;i<this.fns[type].length;i++ ){this.element.detachEvent('on'+type, this.fns[type][i] );}}delete this.fns[type];}},
style:function(s, p){if( typeof s === 'string' ){this.element.style[s]=p||'';}else{var el=this.element;for( var i in s ){el.style[i]=s[i];}}},
styleVp:function(p, v){var vp=this.vp;if( typeof p === 'string' ){this.styleLcc(p, v);this.styleLcc(vp+p, v);}else{for( var k in p ){v=p[k];this.styleLcc(k, v);this.styleLcc(vp+k, v);if( k==='opacity'){this.filterAlpha({'opacity':v*100});}else if( k==='dropshadow'){this.filterDropshadow({'dropshadow':v});}else if( k==='gradient'){this.filterGradient({'gradient':v});}}}},
styleLcc:function(s, p){var el=this.element;if( typeof s === 'string' ){s=this.lcc(s);this.style(s,p);if(this.vp==='-moz-' && s.match(/^moz/))this.style('M'+s.substring(1), p);}else{var moz=(this.vp==='-moz-');for( var i in s ){p=this.lcc(i);this.style(s,p);if( moz && p.match(/^moz/) )this.style('M'+s.substring(1), p);}}},
css:function(newName, oldName){if( !oldName ){this.element.className=newName;}else{var cn=this.element.className.split(/\s+/);var buf=new Array();buf[0]=newName;for( var i=0; i<cn.length; i++ ){if( cn[i]!==oldName ){buf[buf.length]=cn[i];}}this.element.className=buf.join(' ');}},
lcc:function(t){t=t.replace(/-(.)/g, function(m,a){return a.toUpperCase()}).replace(/^(.)/, function(m,a){return a.toLowerCase()});return t;},
filterAlpha:function(arg){if( this.element.style.filter!==undefined ){if( !this.element.style.filter ){this.element.style.filter = 'alpha(opacity='+arg.opacity+')';}else{this.element.style.filter += 'alpha(opacity='+arg.opacity+')';}}return this;},
filterDropshadow:function(arg){},filterGradient:function(arg){},
removeFrom:function(del){if ( this.parent ){this.parent.remove(this);}else if( this.element.parentNode ){this.element.parentNode.removeChild(this.element);}},
remove:function( child ){if( child.constructor==this.constructor ){for( var c in this.childs ){if( this.childs[c]==child ){this.childs[c].destroy(true);this.childs.splice(c, 1);break;}}}else if( this.childs[child] ){this.childs[child].destroy(true);this.childs.splice(child, 1);}else if( child==='text' && this.element.firstChild && this.element.firstChild.nodeType===3 ){ this.element.removeChild(this.element.firstChild); }return this;},
add: function(child, before){if(child.constructor==this.constructor){this.childs.push(child);child.parent=this;this.element.insertBefore(child.element, before?( before.constructor === this.constructor )?before.element:before:null);}else{this.element.insertBefore(child, before||null);}return this;},
addTo: function(parent, before){if(parent.constructor==this.constructor){parent.add(this);}else{parent.insertBefore(this.element, before||null);}return this;},
attr: function(key, value){if( arguments.length===2 ){this.element.setAttribute(key, value);return this;}else if(arguments.length===1){return this.element.getAttribute(key);}else{return '';}},
resizeTo:function(w,h){this.w=(w!=null)?w:this.w;this.h=(h!=null)?h:this.h;this.style({width: (isNaN(this.w)?this.w:this.w+'px'),height:(isNaN(this.h)?this.h:this.h+'px')});return this;},
resizeBy:function(w,h){if(!isNaN(this.w))this.w+=w;if(!isNaN(this.h))this.h+=h;this.resizeTo();return this;},
moveTo:function(x,y){this.x=(x!=null)?x:this.x;this.y=(y!=null)?y:this.y;this.style({left:(isNaN(this.x)?this.x:this.x+'px'),top:(isNaN(this.y)?this.y:this.y+'px')});return this;},
moveBy:function(x,y){if(!isNaN(x))this.x+=x;if(!isNaN(y))this.y+=y;this.moveTo();return this;},
top: function(arg){if( arguments.length ){this.moveTo(null, arg);return this;}return this.y;},
left: function(arg){if( arguments.length ){this.moveTo(arg, null);return this;}return this.x;},
bottom:function(arg){if( arguments.length ){if(isNaN(this.y)){this.style('bottom',arg);}else{this.h=arg-this.y;this.resizeTo();}return this;}return isNaN(this.y)?0:this.y+this.h;},
right:function(arg){if( arguments.length ){if(isNaN(this.x)){this.style('right',arg);}else{this.w=arg-this.x;this.resizeTo();}return this;}return isNaN(this.x)?0:this.x+this.w;},
width:function(arg){if( arguments.length ){this.resizeTo(arg,null);return this;}return this.w;},
height:function(arg){if( arguments.length ){this.resizeTo(null,arg);return this;}return this.h;},
bg:function(url,px,py){if( py==undefined ){py='0';}if( px==undefined ){px='0';}this.style({backgroundImage:'url('+url+')', backgroundRepeat:'no-repeat',backgroundPosition:py+' '+px});return this;},
setAnim:function(sz, fps, fin){if( typeof(sz) == 'number' ){this.setAnim_N(sz);}else{this.setAnim_A(sz, fps, fin);}fps=fps||10;this.fps=1000/fps;fin=fin?fin:1;this.fin=(this.splite.limit>fin)?fin:this.splite.limit;},
setAnim_N:function(sz){var splite=this.splite;splite.width=sz;splite.height=Number(this.h);splite.limit=Math.floor(sz/this.w);},
setAnim_A:function(sz, fps, fin){var splite=this.splite;splite.width=( sz.width!==undefined )?Number(sz.width):Number(this.w);splite.height=( sz.height!==undefined )?Number(sz.height):Number(this.h);if( sz.limit!==undefined ){splite.limit=Number(sz.limit);}else{var w=this.w||splite.width;var h=this.h||splite.height;w=( w==0 )?1:Math.floor(splite.width/w);h=( h==0 )?1:Math.floor(splite.height/h);splite.limit=w*h;}},
anim:function(t){if( this.fps ){var splite=this.splite,szw=( splite.width===0 )?1:Math.floor(splite.width/this.w),szh=( splite.height===0 )?1:Math.floor(splite.height/this.h),cells=szw;if( t===0 ){this.aniStep=this.timeStamp=0;}else if( t-this.timeStamp>=this.fps ){this.timeStamp=t;this.aniStep++;}if( this.aniStep>=splite.limit ){this.aniStep=0;}szw=(this.aniStep%cells)*this.w;szh=Math.floor(this.aniStep/cells)*this.h;this.style('backgroundPosition', '-'+szw+'px -'+szh+'px');}for( var i=0;i<this.childs.length;this.childs[i++].anim(t) );return 1;},
animR:function(t){if( this.fps ){var splite=this.splite,szw=( splite.width===0 )?1:Math.floor(splite.width/this.w),szh=( splite.height===0 )?1:Math.floor(splite.height/this.h),cells=szw;if( t===0 ){this.aniStep=splite.limit-1;this.timeStamp=0;}else if( t-this.timeStamp>=this.fps ){this.timeStamp=t;this.aniStep--;}if(this.aniStep < 0 ){this.aniStep=splite.limit-1;}szw=(this.aniStep%cells)*this.w;szh=Math.floor(this.aniStep/cells)*this.h;this.style('backgroundPosition', '-'+szw+'px -'+szh+'px');}for( var i=0;i<this.childs.length;this.childs[i++].animR(t) );return 1;},
finAnim:function(){if( this.fin!=null ){var splite=this.splite,szw=( splite.width===0 )?1:Math.floor(splite.width/this.w),szh=( splite.height===0 )?1:Math.floor(splite.height/this.h),cells=szw,fin=this.fin-1;szw=(fin%cells)*szw;szh=Math.floor(fin/cells)*szh;this.style('backgroundPosition', '-'+szw+'px -'+szh+'px');}for( var i=0;i<this.childs.length;this.childs[i++].finAnim() );return 1;},
destroy:function(del){for(var i=this.childs.length-1;i>=0;i-- ){this.childs[i].destroy(del);delete this.childs[i]}delete this.parent;for(var i in this.fns){this.removeEvent(i);}if( this.element.parentNode )this.element.parentNode.removeChild(this.element);delete this.element;},
toString:function(){return 'Ess:'+this.id+'-'+this.element.nodeName+'-'+this.element.className;},
text:function(t){for( var i=this.childs.length-1;i>=0;i-- ){this.remove(i);}this.remove('text');this.element.appendChild(document.createTextNode(t));}
}
Element.prototype.init=function(tag, cls, style){
if( tag=='img' )this.attr('src','data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACH5BAkAAAEALAAAAAABAAEAAAICTAEAOw==');
this.id=this.element.id=(String(cls)).replace(/\s/g,'-');
this.css(cls);
this.style({position:'absolute',border:'0 none',borderRadius:'0',margin:'0',padding:'0',display:'block',backgroundColor:'transparent',backgroundImage:'none'});
this.styleVp({opacity:'1.0',borderRadius:'0'});
this.moveTo(style.left, style.top);
this.resizeTo(style.width, style.height);
if(style.top==null) this.style('top','auto');
if(style.left==null) this.style('left','auto');
if(style.width==null) this.style('width','auto');
if(style.height==null) this.style('height','auto');
};
})();

if( window.document && window.document.body ){
Dabmaki.init();Dabmaki.init=function(){};
}else if( window.addEventListener ){
window.addEventListener('DOMContentLoaded', function(e){window.removeEventListener('DOMContentLoaded', arguments.callee, false);Dabmaki.init();Dabmaki.init=function(){};}, false);
window.addEventListener('load', function(e){window.removeEventListener('load', arguments.callee, false);Dabmaki.init();Dabmaki.init=function(){};}, false);
}else if( window.attachEvent ){
window.attachEvent('onload', function(e){window.detachEvent('onload', arguments.callee);Dabmaki.init();Dabmaki.init=function(){};});
}
